org.apache.pdfbox.pdmodel.font

## Class PDType1Font

- java.lang.Object
- - org.apache.pdfbox.pdmodel.font.PDFont
  - - org.apache.pdfbox.pdmodel.font.PDSimpleFont
    - - org.apache.pdfbox.pdmodel.font.PDType1Font

All Implemented Interfaces:
  COSObjectable, PDFontLike

Direct Known Subclasses:
  PDMMType1Font

    public class PDType1Font
    extends PDSimpleFont

A PostScript Type 1 Font.

Author:
  Ben Litchfield

### Field Summary

Fields
`static PDType1Font` `COURIER`
`static PDType1Font` `COURIER_BOLD`
`static PDType1Font` `COURIER_BOLD_OBLIQUE`
`static PDType1Font` `COURIER_OBLIQUE`
`static PDType1Font` `HELVETICA`
`static PDType1Font` `HELVETICA_BOLD`
`static PDType1Font` `HELVETICA_BOLD_OBLIQUE`
`static PDType1Font` `HELVETICA_OBLIQUE`
`static PDType1Font` `SYMBOL`
`static PDType1Font` `TIMES_BOLD`
`static PDType1Font` `TIMES_BOLD_ITALIC`
`static PDType1Font` `TIMES_ITALIC`
`static PDType1Font` `TIMES_ROMAN`
`static PDType1Font` `ZAPF_DINGBATS`

### Fields inherited from class org.apache.pdfbox.pdmodel.font.PDSimpleFont

`encoding, glyphList`

### Fields inherited from class org.apache.pdfbox.pdmodel.font.PDFont

`DEFAULT_FONT_MATRIX, dict`

### Constructor Summary

Constructors
Constructor and Description
`PDType1Font(COSDictionary fontDictionary)` Creates a Type 1 font from a Font dictionary in a PDF.
`PDType1Font(PDDocument doc, InputStream pfbIn)` Creates a new Type 1 font for embedding.
`PDType1Font(PDDocument doc, InputStream pfbIn, Encoding encoding)` Creates a new Type 1 font for embedding.

### Method Summary

All Methods Instance Methods Concrete Methods
`String` `codeToName(int code)`
`protected byte[]` `encode(int unicode)` Encodes the given Unicode code point for use in a PDF content stream.
`float` `getAverageFontWidth()` This will get the average font width for all characters.
`String` `getBaseFont()` Returns the PostScript name of the font.
`org.apache.fontbox.util.BoundingBox` `getBoundingBox()` Returns the font's bounding box.
`org.apache.fontbox.FontBoxFont` `getFontBoxFont()` Returns the embedded or system font used for rendering.
`Matrix` `getFontMatrix()` Returns the font matrix, which represents the transformation from glyph space to text space.
`float` `getHeight(int code)` Returns the height of the given character, in glyph space.
`String` `getName()` Returns the name of this font, either the PostScript "BaseName" or the Type 3 "Name".
`GeneralPath` `getPath(String name)` Returns the path for the character with the given name.
`org.apache.fontbox.type1.Type1Font` `getType1Font()` Returns the embedded or substituted Type 1 font, or null if there is none.
`float` `getWidthFromFont(int code)` Returns the width of a glyph in the embedded font file.
`boolean` `hasGlyph(String name)` Returns true if the font contains the character with the given name.
`boolean` `isDamaged()` Returns true if the embedded font file is damaged.
`boolean` `isEmbedded()` Returns true if the font file is embedded in the PDF.
`int` `readCode(InputStream in)` Reads a character code from a content stream string.
`protected Encoding` `readEncodingFromFont()` Called by readEncoding() if the encoding needs to be extracted from the font file.

### Methods inherited from class org.apache.pdfbox.pdmodel.font.PDSimpleFont

`addToSubset, getEncoding, getGlyphList, getStandard14Width, getSymbolicFlag, hasExplicitWidth, isFontSymbolic, isStandard14, isSymbolic, isVertical, readEncoding, subset, toUnicode, toUnicode, willBeSubset`

### Methods inherited from class org.apache.pdfbox.pdmodel.font.PDFont

`encode, equals, getCOSObject, getDisplacement, getFontDescriptor, getPositionVector, getSpaceWidth, getStandard14AFM, getStringWidth, getSubType, getToUnicodeCMap, getType, getWidth, getWidths, hashCode, readCMap, setFontDescriptor, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### TIMES_ROMAN

    public static final PDType1Font TIMES_ROMAN

#### TIMES_BOLD

    public static final PDType1Font TIMES_BOLD

#### TIMES_ITALIC

    public static final PDType1Font TIMES_ITALIC

#### TIMES_BOLD_ITALIC

    public static final PDType1Font TIMES_BOLD_ITALIC

#### HELVETICA

    public static final PDType1Font HELVETICA

#### HELVETICA_BOLD

    public static final PDType1Font HELVETICA_BOLD

#### HELVETICA_OBLIQUE

    public static final PDType1Font HELVETICA_OBLIQUE

#### HELVETICA_BOLD_OBLIQUE

    public static final PDType1Font HELVETICA_BOLD_OBLIQUE

#### COURIER

    public static final PDType1Font COURIER

#### COURIER_BOLD

    public static final PDType1Font COURIER_BOLD

#### COURIER_OBLIQUE

    public static final PDType1Font COURIER_OBLIQUE

#### COURIER_BOLD_OBLIQUE

    public static final PDType1Font COURIER_BOLD_OBLIQUE

#### SYMBOL

    public static final PDType1Font SYMBOL

#### ZAPF_DINGBATS

    public static final PDType1Font ZAPF_DINGBATS

### Constructor Detail

#### PDType1Font

    public PDType1Font(PDDocument doc,
                       InputStream pfbIn)
                throws IOException

Creates a new Type 1 font for embedding.

Parameters:
  `doc` - PDF document to write to
  `pfbIn` - PFB file stream
Throws:
  `IOException`

#### PDType1Font

    public PDType1Font(PDDocument doc,
                       InputStream pfbIn,
                       Encoding encoding)
                throws IOException

Creates a new Type 1 font for embedding.

Parameters:
  `doc` - PDF document to write to
  `pfbIn` - PFB file stream
  `encoding` -
Throws:
  `IOException`

#### PDType1Font

    public PDType1Font(COSDictionary fontDictionary)
                throws IOException

Creates a Type 1 font from a Font dictionary in a PDF.

Parameters:
  `fontDictionary` - font dictionary.
Throws:
  `IOException` - if there was an error initializing the font.
  `IllegalArgumentException` - if /FontFile3 was used.

### Method Detail

#### getBaseFont

    public final String getBaseFont()

Returns the PostScript name of the font.

#### getHeight

    public float getHeight(int code)
                    throws IOException

Description copied from interface: `PDFontLike`
Returns the height of the given character, in glyph space. This can be expensive to calculate. Results are only approximate.

Warning: This method is deprecated in PDFBox 2.0 because there is no meaningful value which it can return. The `PDFontLike.getWidth(int)` method returns the advance width of a glyph, but there is no corresponding advance height. The logical height of a character is the same for every character in a font, so if you want that, retrieve the font bbox's height. Otherwise if you want the visual bounds of the glyph then call getPath(..) on the appropriate PDFont subclass to retrieve the glyph outline as a GeneralPath. See the cyan rectangles in the DrawPrintTextLocations.java example to see this in action.

Parameters:
  `code` - character code
Throws:
  `IOException`

#### encode

    protected byte[] encode(int unicode)
                     throws IOException

Description copied from class: `PDFont`
Encodes the given Unicode code point for use in a PDF content stream. Content streams use a multi-byte encoding with 1 to 4 bytes.

This method is called when embedding text in PDFs and when filling in fields.

Specified by:
  `encode` in class `PDFont`
Parameters:
  `unicode` - Unicode code point.
Returns:
  Array of 1 to 4 PDF content stream bytes.
Throws:
  `IOException` - If the text could not be encoded.

#### getWidthFromFont

    public float getWidthFromFont(int code)
                           throws IOException

Description copied from interface: `PDFontLike`
Returns the width of a glyph in the embedded font file.

Parameters:
  `code` - character code
Returns:
  width in glyph space
Throws:
  `IOException` - if the font could not be read

#### isEmbedded

    public boolean isEmbedded()

Description copied from interface: `PDFontLike`
Returns true if the font file is embedded in the PDF.

#### getAverageFontWidth

    public float getAverageFontWidth()

Description copied from class: `PDFont`
This will get the average font width for all characters.

Specified by:
  `getAverageFontWidth` in interface `PDFontLike`
Overrides:
  `getAverageFontWidth` in class `PDFont`
Returns:
  The width is in 1000 unit of text space, ie 333 or 777

#### readCode

    public int readCode(InputStream in)
                 throws IOException

Description copied from class: `PDFont`
Reads a character code from a content stream string. Codes may be up to 4 bytes long.

Specified by:
  `readCode` in class `PDFont`
Parameters:
  `in` - string stream
Returns:
  character code
Throws:
  `IOException` - if the CMap or stream cannot be read

#### readEncodingFromFont

    protected Encoding readEncodingFromFont()
                                     throws IOException

Description copied from class: `PDSimpleFont`
Called by readEncoding() if the encoding needs to be extracted from the font file.

Specified by:
  `readEncodingFromFont` in class `PDSimpleFont`
Throws:
  `IOException` - if the font file could not be read.

#### getType1Font

    public org.apache.fontbox.type1.Type1Font getType1Font()

Returns the embedded or substituted Type 1 font, or null if there is none.

#### getFontBoxFont

    public org.apache.fontbox.FontBoxFont getFontBoxFont()

Description copied from class: `PDSimpleFont`
Returns the embedded or system font used for rendering. This is never null.

Specified by:
  `getFontBoxFont` in class `PDSimpleFont`

#### getName

    public String getName()

Description copied from interface: `PDFontLike`
Returns the name of this font, either the PostScript "BaseName" or the Type 3 "Name".

#### getBoundingBox

    public org.apache.fontbox.util.BoundingBox getBoundingBox()
                                                       throws IOException

Description copied from interface: `PDFontLike`
Returns the font's bounding box.

Throws:
  `IOException`

#### codeToName

    public String codeToName(int code)
                      throws IOException

Throws:
  `IOException`

#### getPath

    public GeneralPath getPath(String name)
                        throws IOException

Description copied from class: `PDSimpleFont`
Returns the path for the character with the given name. For some fonts, GIDs may be used instead of names when calling this method.

Specified by:
  `getPath` in class `PDSimpleFont`
Returns:
  glyph path
Throws:
  `IOException` - if the path could not be read

#### hasGlyph

    public boolean hasGlyph(String name)
                     throws IOException

Description copied from class: `PDSimpleFont`
Returns true if the font contains the character with the given name.

Specified by:
  `hasGlyph` in class `PDSimpleFont`
Throws:
  `IOException` - if the path could not be read

#### getFontMatrix

    public final Matrix getFontMatrix()

Description copied from interface: `PDFontLike`
Returns the font matrix, which represents the transformation from glyph space to text space.

Specified by:
  `getFontMatrix` in interface `PDFontLike`
Overrides:
  `getFontMatrix` in class `PDFont`

#### isDamaged

    public boolean isDamaged()

Description copied from interface: `PDFontLike`
Returns true if the embedded font file is damaged.